class Car:
    """Car Class"""
    #module name = filename (pyCar.py)
    def __init__(self):
        #a constructor - method invoked when create an object (by calling Car), don't need this unless need stuff
        # in "constructor"
        self.speed = 0
        self.odometer = 0
        self.time = 0
        #don't have to define vari, but this sets them up globally for class

    def say_state(self):
        print("I'm going {} kph!".format(self.speed))
        #each of these are more methods
        #vari created here - only live here, created when come in and die when leave, but they get the "self.X" vari.

    def accelerate(self):
        self.speed += 5

    def brake(self):
        self.speed -= 5

    def step(self):
        self.odometer += self.speed
        self.time += 1

    def average_speed(self):
        """Ave Speed report"""
        #to report this use pyCar.Car.average_speed.__doc__
        return self.odometer / self.time


if __name__ == '__main__':
    #this asks if running it as a script, this prevents it from being run when you import it
    #import imports module, not "script"
    my_car = Car()
    print("I'm a car!")
    while True:
        action = raw_input("What should I do? [A]ccelerate, [B]rake, show [O]dometer, or show average [S]peed, or quit [Q]uit? ").upper()
        if action not in "ABOSQ" or len(action) != 1:
            print("I don't know how to do that")
            continue
        else:
            if action == 'Q':
                break
        if action == 'A':
            my_car.accelerate()
        elif action == 'B':
            my_car.brake()
        elif action == 'O':
            print("The car has driven {} kilometers".format(my_car.odometer))
        elif action == 'S':
            print("The car's average speed was {} kph".format(my_car.average_speed()))
        my_car.step()
        my_car.say_state()
