import matplotlib.pyplot as plt

#notes say the original size is somewhat arbitrary - not really - figsize specifies figure size has nothing to do with subplots.
#figsize : (float, float), optional, default: None
#    width, height in inches. If not provided, defaults to rcParams["figure.figsize"] = [6.4, 4.8].
#https://matplotlib.org/3.1.0/api/_as_gen/matplotlib.pyplot.figure.html

fig = plt.figure() #have to open figure - creates object fig, then below call ".addsubplot" method to add a subplot
#fig = plt.figure(figsize=(16,16))

#divide figure into 1 row and 2 columns and take the first "cell"
ax1 = fig.add_subplot(1, 2, 1, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="red",)
#facecolor : color spec the background color. If not provided, defaults to rcParams["figure.facecolor"] = 'w'.
#this naming is confusing, why not call it background color? Have to understand more to figure out how named (similar to indexing - there is a method to the madness)
#etc for other parameeters - ticks, labels

#each division is independent
ax2 = fig.add_subplot(2, 2, 2, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="blue")
#ax2 = fig.add_subplot(4, 4, 2, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="blue")

ax3 = fig.add_subplot(4, 2, 6, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="yellow")
ax4 = fig.add_subplot(8, 2, 14, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="green")
ax5 = fig.add_subplot(8, 2, 16, xticklabels=[], yticklabels=[], xticks=[], yticks=[], fc="orange")

ax1.text(0.5, 0.5, "ax1", horizontalalignment='center', verticalalignment='center')
ax2.text(0.5, 0.5, "ax2", horizontalalignment='center', verticalalignment='center')
ax3.text(0.5, 0.5, "ax3", horizontalalignment='center', verticalalignment='center')
ax4.text(0.5, 0.5, "ax4", horizontalalignment='center', verticalalignment='center')
ax5.text(0.5, 0.5, "ax5", horizontalalignment='center', verticalalignment='center')

plt.show()
